## Installation

1. [Install docker](https://docs.docker.com/engine/install/) `curl -fsSL https://get.docker.com | sudo sh`
2. Give yourself docker group and relogin.
`sudo usermod -aG docker $USER;sudo su - $USER`
3. Save the below content as `docker-compose.yml`
```yml
version: '3.5'
services:
#########################
   dscrap:
      image: git.shihaam.dev/dockerfiles/dhiraagu-scrapper
      environment:
       - SCRAPPER_CONTROL_API_KEY= #GET KEY FROM ATHFAN
#       - TG_BOT_TOKEN= # modify if needed, default value set during build
#       - CHAT_ID=# modify if needed, default value set during build
      deploy:
       replicas: 5 # Change this to however number of multiple instanaces you want
```
4. Modify `SCRAPPER_CONTROL_API_KEY`
5. Run `docker compose up -d`

## View scrapper progress:
```
docker compose logs -f
```

## HOW TO KILL THE CONTAINER
```
docker compose down
```
